<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>AlexaClientSDK: alexaClientSDK::adsl::DirectiveProcessor Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="avs-logo.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">AlexaClientSDK
   &#160;<span id="projectnumber">1.13.0</span>
   </div>
   <div id="projectbrief">A cross-platform, modular SDK for interacting with the Alexa Voice Service</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="namespacealexa_client_s_d_k.html">alexaClientSDK</a></li><li class="navelem"><a class="el" href="namespacealexa_client_s_d_k_1_1adsl.html">adsl</a></li><li class="navelem"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#nested-classes">Classes</a> &#124;
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">alexaClientSDK::adsl::DirectiveProcessor Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="_directive_processor_8h_source.html">DirectiveProcessor.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a43c583510353b8020de277ea98277acb"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a43c583510353b8020de277ea98277acb">DirectiveProcessor</a> (<a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a> *directiveRouter)</td></tr>
<tr class="separator:a43c583510353b8020de277ea98277acb"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a58fe40618370125a058a6ebcd3ad6e76"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a58fe40618370125a058a6ebcd3ad6e76">~DirectiveProcessor</a> ()</td></tr>
<tr class="separator:a58fe40618370125a058a6ebcd3ad6e76"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a79f12de0f2919c6cd38cb0452c5b8523"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a79f12de0f2919c6cd38cb0452c5b8523">setDialogRequestId</a> (const std::string &amp;dialogRequestId)</td></tr>
<tr class="separator:a79f12de0f2919c6cd38cb0452c5b8523"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a90f8c546cb39a806374911fa73759013"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">onDirective</a> (std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt; directive)</td></tr>
<tr class="separator:a90f8c546cb39a806374911fa73759013"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae2faaf7acc90e86198035959717b24d2"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#ae2faaf7acc90e86198035959717b24d2">shutdown</a> ()</td></tr>
<tr class="separator:ae2faaf7acc90e86198035959717b24d2"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abd74610d3b03928586673816b9b983bf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#abd74610d3b03928586673816b9b983bf">disable</a> ()</td></tr>
<tr class="separator:abd74610d3b03928586673816b9b983bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a099e3796f20c3081d9479d25b2c87626"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a099e3796f20c3081d9479d25b2c87626">enable</a> ()</td></tr>
<tr class="separator:a099e3796f20c3081d9479d25b2c87626"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p class="">Object to process <code>AVSDirectives</code> that have a non-empty <code>dialogRequestId</code>. </p><dl class="section user"><dt></dt><dd><code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a></code> receives directives via its <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">onDirective()</a></code> method. The <code>dialogRequestId</code> property of incoming directives is checked against the current <code>dialogRequestId</code> (which is set by <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a79f12de0f2919c6cd38cb0452c5b8523">setDialogRequestId()</a></code>). If the <code>AVSDirective's</code> value is not empty and does not match, the <code>AVSDirective</code> is dropped, and <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">onDirective()</a></code> returns <code>true</code> to indicate that the <code>AVSDirective</code> has been consumed (in this case, because it is not longer relevant). </dd></dl>
<dl class="section user"><dt></dt><dd>After passing this hurdle, the <code>AVSDirective</code> is forwarded to the <code>preHandleDirective()</code> method of whichever <code>DirectiveHandler</code> is registered to handle the <code>AVSDirective</code>. If no <code>DirectiveHandler</code> is registered, the incoming directive is rejected and any directives with the same dialogRequestId that are already queued for handling by the <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a></code> are canceled (because an entire dialog is canceled when the handling of any of its directives fails), and <code><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html#a90f8c546cb39a806374911fa73759013">onDirective()</a></code> returns <code>false</code> to indicate that the unhandled <code>AVDirective</code> was rejected. </dd></dl>
<dl class="section user"><dt></dt><dd>Once an <code>AVSDirective</code> has been successfully forwarded for preHandling, it is enqueued awaiting its turn to be handled. Handling is accomplished by forwarding the <code>AVSDirective</code> to the <code>handleDirective()</code> method of whichever <code>DirectiveHandler</code> is registered to handle the <code>AVSDirective</code>. The handling of an <code>AVSDirective</code> can be configured as <code>BLOCKING</code> or <code>NON_BLOCKING</code>. If the directive at the head of the handling queue is configured for <code>BLOCKING</code>, the handling of subsequent <code>AVSDirectives</code> is held up until the <code>DirectiveHandler</code> for the <code>BLOCKING</code> <code>AVSDirective</code> indicates that handling has completed or failed. Otherwise handleDirective() is invoked, the <code>AVSDirective</code> is popped from the front of the queue, and processing of queued <code>AVSDirective's</code> continues. </dd></dl>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a43c583510353b8020de277ea98277acb"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a43c583510353b8020de277ea98277acb">&#9670;&nbsp;</a></span>DirectiveProcessor()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::adsl::DirectiveProcessor::DirectiveProcessor </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_router.html">DirectiveRouter</a> *&#160;</td>
          <td class="paramname"><em>directiveRouter</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Constructor.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directiveRouter</td><td>An object used to route directives to their registered handler. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a58fe40618370125a058a6ebcd3ad6e76"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a58fe40618370125a058a6ebcd3ad6e76">&#9670;&nbsp;</a></span>~DirectiveProcessor()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">alexaClientSDK::adsl::DirectiveProcessor::~DirectiveProcessor </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Destructor. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="abd74610d3b03928586673816b9b983bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abd74610d3b03928586673816b9b983bf">&#9670;&nbsp;</a></span>disable()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::adsl::DirectiveProcessor::disable </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Disable the <a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a>, queues all outstanding <code>AVSDirectives</code> for cancellation and blocks until the processing of all <code>AVSDirectives</code> has completed. </p>

</div>
</div>
<a id="a099e3796f20c3081d9479d25b2c87626"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a099e3796f20c3081d9479d25b2c87626">&#9670;&nbsp;</a></span>enable()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveProcessor::enable </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Enable the <a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a>.</p>
<dl class="section return"><dt>Returns</dt><dd>Whether it succeeded to enable the directive processor. </dd></dl>

</div>
</div>
<a id="a90f8c546cb39a806374911fa73759013"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a90f8c546cb39a806374911fa73759013">&#9670;&nbsp;</a></span>onDirective()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">bool alexaClientSDK::adsl::DirectiveProcessor::onDirective </td>
          <td>(</td>
          <td class="paramtype">std::shared_ptr&lt; <a class="el" href="classalexa_client_s_d_k_1_1avs_common_1_1avs_1_1_a_v_s_directive.html">avsCommon::avs::AVSDirective</a> &gt;&#160;</td>
          <td class="paramname"><em>directive</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Queue an <code>AVSDirective</code> for handling by whatever <code>DirectiveHandler</code> was registered to handle it.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">directive</td><td>The <code>AVADirective</code> to process. </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>Whether the directive was consumed. </dd></dl>

</div>
</div>
<a id="a79f12de0f2919c6cd38cb0452c5b8523"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a79f12de0f2919c6cd38cb0452c5b8523">&#9670;&nbsp;</a></span>setDialogRequestId()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::adsl::DirectiveProcessor::setDialogRequestId </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>dialogRequestId</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Set the current <code>dialogRequestId</code>. If a new value is specified any <code>AVSDirective's</code> whose pre-handling or handling is already in progress the directive will be cancelled.</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dialogRequestId</td><td>The new value for the current <code>dialogRequestId</code>. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae2faaf7acc90e86198035959717b24d2"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae2faaf7acc90e86198035959717b24d2">&#9670;&nbsp;</a></span>shutdown()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void alexaClientSDK::adsl::DirectiveProcessor::shutdown </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">
<p class="">Shut down the <a class="el" href="classalexa_client_s_d_k_1_1adsl_1_1_directive_processor.html">DirectiveProcessor</a>. This queues all outstanding <code>AVSDirectives</code> for cancellation and blocks until the processing of all <code>AVSDirectives</code> has completed. </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>/workplace/avs-device-sdk/ADSL/include/ADSL/<a class="el" href="_directive_processor_8h_source.html">DirectiveProcessor.h</a></li>
<li>/workplace/avs-device-sdk/ADSL/src/<a class="el" href="_directive_processor_8cpp.html">DirectiveProcessor.cpp</a></li>
</ul>
</div><!-- contents -->
<html>
  <body>
    <p style="text-align:left;">
      AlexaClientSDK 1.13.0 - Copyright 2016-2019 Amazon.com, Inc. or its affiliates. All Rights Reserved.
      <span style="float:right;">
	Licensed under the <a HREF=http://aws.amazon.com/apache2.0/>Apache License, Version 2.0</a>
      </span>
    </p>
  </body>
</html>
